//!   ,        maxN,
//  ,      ,  
//              .
// ,   ,      ,   
//  .

#include <iostream>
#include <vector>
#include <queue>

using namespace std;

const int maxD = 20000;
const int maxN = 15;

struct state
{
   int x, d, s;
   state(int x1, int d1, int s1): x(x1), d(d1), s(s1) {}
};

int d, k, m, r[maxN];
int a[2*maxD+1][maxN][maxN];
int ans;
queue<state> q;

void go(state s1, state s2)
{
   if (s2.x < -maxD || s2.x > maxD || s2.s > k) return;
   int &t = a[s2.x+maxD][s2.d][s2.s];
   if (t >= 0) return;
   t = a[s1.x+maxD][s1.d][s1.s] + 1;
   q.push(s2);
   if (s2.x == d && ans < 0) ans = t;
}

int main()
{
   freopen("input.txt", "r", stdin); freopen("output.txt", "wt", stdout);

   cin >> d >> k >> m;
   int i;
   for (i = 0; i < m; i++) cin >> r[i];
   
   memset(a, 255, sizeof(a));
   a[0+maxD][0][0] = 0; q.push(state(0, 0, 0));
   ans = -1;
   while (!q.empty()) {
      state cur = q.front();
      go(cur, state(cur.x-r[cur.d], (cur.d+1)%m, cur.s));
      go(cur, state(cur.x+r[cur.d], (cur.d+1)%m, cur.s));
      go(cur, state(cur.x, (cur.d+1)%m, cur.s+1));
      q.pop();
   }
   
   if (!d) cout << 0; else cout << ans;

   fclose(stdin); fclose(stdout);
   return 0;
}